> For the complete documentation index, see [llms.txt](https://docs.nuvolos.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nuvolos.com/reference/applications/create-a-persistent-.bashrc.md).

# Shell and startup configuration

## Persistent .bashrc

In Nuvolos, the \~/[.bashrc](https://www.digitalocean.com/community/tutorials/bashrc-file-in-linux) file is generated automatically and is tailored for each Application. Edits to this file are lost on Application restart. To create a persistent .bashrc:&#x20;

* For instances created after 2022-02-08, Nuvolos generates a default file at `/files/.nuvolos/.bashrc`. We recommend not modifying this file directly.
* Instead, create a custom .bashrc at `/files/.bashrc`. The system automatically sources this file when opening a new shell session.
* If your `/files/.bashrc` does not appear to load, the system-generated `/files/.nuvolos/.bashrc` may be corrupted or accidentally deleted. In that case, define your own configuration directly in `/files/.nuvolos/.bashrc`.

## Disable core dump files

When a process crashes due to a serious failure, the operating system might create a core dump file of the process's memory before the crash. This file can be rather large depending on the memory usage of the process.

Luckily, you can disable core dump files by issuing the following command in a bash terminal:

```
ulimit -c 0
```

{% hint style="info" %}
The ulimit command will only have affect on the terminal session where it is executed!
{% endhint %}

To make sure every terminal opened in your Nuvolos app has core dumps turned off, you can put this in to your custom .bashrc.

## Automatic code execution on startup

Nuvolos supports automated code execution on Application startup. This is useful for running initialisation steps on each startup, or automatically starting a calculation on Application startup.

Define a startup.sh file in the workspace (located at `/files/startup.sh` inside the running Application). It is executed automatically in the background via bash on Application startup.

Because startup.sh runs as a separate background process, you cannot directly modify properties of the main Application from it (such as visual editor font size). For such cases, consult the documentation of the Application for commands executed on each startup.

The standard output and error streams of the script are redirected to `/files/startup.log`, so you can track its progress in real time.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.nuvolos.com/reference/applications/create-a-persistent-.bashrc.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
